diff -r e32ff462bf6e trytond/modules/account_invoice/invoice.py
--- a/trytond/modules/account_invoice/invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1017,326 +949,295 @@
         default.setdefault('accounting_date', None)
         default['lines_to_pay'] = None
 
-        new_ids = []
-        for invoice in self.browse(ids):
-            new_id = super(Invoice, self).copy(invoice.id, default=default)
-            line_obj.copy([x.id for x in invoice.lines], default={
-                'invoice': new_id,
-                })
-            tax_obj.copy([x.id for x in invoice.taxes], default={
-                'invoice': new_id,
-                })
-            new_ids.append(new_id)
+        new_invoices = []
+        for invoice in invoices:
+            new_invoice, = super(Invoice, cls).copy([invoice], default=default)
+            Line.copy(invoice.lines, default={
+                    'invoice': new_invoice.id,
+                    })
+            Tax.copy(invoice.taxes, default={
+                    'invoice': new_invoice.id,
+                    })
+            new_invoices.append(new_invoice)
+        return new_invoices
 
-        if int_id:
-            return new_ids[0]
-        return new_ids
+    def check_account(self):
+        return self.account.company == self.company
 
-    def check_account(self, ids):
-        for invoice in self.browse(ids):
-            if invoice.account.company.id != invoice.company.id:
+    def check_account2(self):
+        for line in self.lines:
+            if (line.type == 'line'
+                    and line.account == self.account):
                 return False
         return True
 
-    def check_account2(self, ids):
-        for invoice in self.browse(ids):
-            for line in invoice.lines:
-                if line.type == 'line' \
-                        and line.account.id == invoice.account.id:
-                    return False
-        return True
-
-    def get_reconcile_lines_for_amount(self, invoice, amount,
-            exclude_ids=None):
+    def get_reconcile_lines_for_amount(self, amount, exclude_lines=None):
         '''
-        Return list of line ids and the remainder to make reconciliation.
+        Return list of lines and the remainder to make reconciliation.
         '''
-        currency_obj = Pool().get('currency.currency')
-
-        if exclude_ids is None:
-            exclude_ids = []
+        if exclude_lines is None:
+            exclude_lines = []
         payment_amount = Decimal('0.0')
-        remainder = invoice.total_amount
+        remainder = self.total_amount
         lines = []
         payment_lines = []
 
-        for line in invoice.payment_lines:
+        for line in self.payment_lines:
             if line.reconciliation:
                 continue
             payment_amount += line.debit - line.credit
-            payment_lines.append(line.id)
+            payment_lines.append(line)
 
-        if invoice.type in ('out_invoice', 'in_credit_note'):
+        if self.type in ('out_invoice', 'in_credit_note'):
             amount = - abs(amount)
         else:
             amount = abs(amount)
 
-        for line in invoice.lines_to_pay:
+        for line in self.lines_to_pay:
 
             if line.reconciliation:
                 continue
-            if line.id in exclude_ids:
+            if line in exclude_lines:
                 continue
 
             test_amount = amount + (line.debit - line.credit)
-            if currency_obj.is_zero(invoice.currency, test_amount):
-                return ([line.id], Decimal('0.0'))
+            if self.currency.is_zero(test_amount):
+                return ([line], Decimal('0.0'))
             if abs(test_amount) < abs(remainder):
-                lines = [line.id]
+                lines = [line]
                 remainder = test_amount
 
             test_amount = (amount + payment_amount)
             test_amount += (line.debit - line.credit)
-            if currency_obj.is_zero(invoice.currency, test_amount):
-                return ([line.id] + payment_lines, Decimal('0.0'))
+            if self.currency.is_zero(test_amount):
+                return ([line] + payment_lines, Decimal('0.0'))
             if abs(test_amount) < abs(remainder):
-                lines = [line.id] + payment_lines
+                lines = [line] + payment_lines
                 remainder = test_amount
 
-            exclude_ids2 = exclude_ids[:]
-            exclude_ids2.append(line.id)
-            res = self.get_reconcile_lines_for_amount(invoice,
-                    (amount + (line.debit - line.credit)),
-                    exclude_ids=exclude_ids2)
-            if res[1] == Decimal('0.0'):
-                res[0].append(line.id)
-                return res
-            if abs(res[1]) < abs(remainder):
-                res[0].append(line.id)
-                lines = res[0]
-                remainder = res[1]
+            exclude_lines2 = exclude_lines[:]
+            exclude_lines2.append(line)
+            lines2, remainder2 = self.get_reconcile_lines_for_amount(
+                (amount + (line.debit - line.credit)),
+                exclude_lines=exclude_lines2)
+            if remainder2 == Decimal('0.0'):
+                lines2.append(line)
+                return lines2, remainder2
+            if abs(remainder2) < abs(remainder):
+                lines2.append(line)
+                lines, remainder = lines2, remainder2
 
         return (lines, remainder)
 
-    def pay_invoice(self, invoice_id, amount, journal_id, date, description,
+    def pay_invoice(self, amount, journal, date, description,
             amount_second_currency=None, second_currency=None):
         '''
-        Add a payment to an invoice
-
-        :param invoice_id: the invoice id
-        :param amount: the amount to pay
-        :param journal_id: the journal id for the move
-        :param date: the date of the move
-        :param description: the description of the move
-        :param amount_second_currency: the amount in the second currenry if one
-        :param second_currency: the id of the second currency
-        :return: the id of the payment line
+        Adds a payment of amount to an invoice using the journal, date and
+        description.
+        Returns the payment line.
         '''
         pool = Pool()
-        journal_obj = pool.get('account.journal')
-        move_obj = pool.get('account.move')
-        period_obj = pool.get('account.period')
+        Move = pool.get('account.move')
+        Period = pool.get('account.period')
 
         lines = []
-        invoice = self.browse(invoice_id)
-        journal = journal_obj.browse(journal_id)
 
-        if invoice.type in ('out_invoice', 'in_credit_note'):
+        if self.type in ('out_invoice', 'in_credit_note'):
             lines.append({
-                'name': description,
-                'account': invoice.account.id,
-                'party': invoice.party.id,
-                'debit': Decimal('0.0'),
-                'credit': amount,
-                'amount_second_currency': amount_second_currency,
-                'second_currency': second_currency,
-            })
+                    'name': description,
+                    'account': self.account.id,
+                    'party': self.party.id,
+                    'debit': Decimal('0.0'),
+                    'credit': amount,
+                    'amount_second_currency': amount_second_currency,
+                    'second_currency': second_currency,
+                    })
             lines.append({
-                'name': description,
-                'account': journal.debit_account.id,
-                'party': invoice.party.id,
-                'debit': amount,
-                'credit': Decimal('0.0'),
-                'amount_second_currency': amount_second_currency,
-                'second_currency': second_currency,
-            })
-            if invoice.account.id == journal.debit_account.id:
+                    'name': description,
+                    'account': journal.debit_account.id,
+                    'party': self.party.id,
+                    'debit': amount,
+                    'credit': Decimal('0.0'),
+                    'amount_second_currency': amount_second_currency,
+                    'second_currency': second_currency,
+                    })
+            if self.account == journal.debit_account:
                 self.raise_user_error('same_debit_account')
             if not journal.debit_account:
                 self.raise_user_error('missing_debit_account')
         else:
             lines.append({
-                'name': description,
-                'account': invoice.account.id,
-                'party': invoice.party.id,
-                'debit': amount,
-                'credit': Decimal('0.0'),
-                'amount_second_currency': amount_second_currency,
-                'second_currency': second_currency,
-            })
+                    'name': description,
+                    'account': self.account.id,
+                    'party': self.party.id,
+                    'debit': amount,
+                    'credit': Decimal('0.0'),
+                    'amount_second_currency': amount_second_currency,
+                    'second_currency': second_currency,
+                    })
             lines.append({
-                'name': description,
-                'account': journal.credit_account.id,
-                'party': invoice.party.id,
-                'debit': Decimal('0.0'),
-                'credit': amount,
-                'amount_second_currency': amount_second_currency,
-                'second_currency': second_currency,
-            })
-            if invoice.account.id == journal.credit_account.id:
+                    'name': description,
+                    'account': journal.credit_account.id,
+                    'party': self.party.id,
+                    'debit': Decimal('0.0'),
+                    'credit': amount,
+                    'amount_second_currency': amount_second_currency,
+                    'second_currency': second_currency,
+                    })
+            if self.account == journal.credit_account:
                 self.raise_user_error('same_credit_account')
             if not journal.credit_account:
                 self.raise_user_error('missing_credit_account')
 
-        period_id = period_obj.find(invoice.company.id, date=date)
+        period_id = Period.find(self.company.id, date=date)
 
-        move_id = move_obj.create({
-            'journal': journal.id,
-            'period': period_id,
-            'date': date,
-            'lines': [('create', x) for x in lines],
-            })
-        move_obj.post(move_id)
-
-        move = move_obj.browse(move_id)
+        move = Move.create({
+                'journal': journal.id,
+                'period': period_id,
+                'date': date,
+                'lines': [('create', x) for x in lines],
+                })
+        Move.post([move])
 
         for line in move.lines:
-            if line.account.id == invoice.account.id:
-                self.write(invoice.id, {
-                    'payment_lines': [('add', line.id)],
-                    })
-                return line.id
+            if line.account == self.account:
+                self.write([self], {
+                        'payment_lines': [('add', [line.id])],
+                        })
+                return line
         raise Exception('Missing account')
 
-    def print_invoice(self, invoice):
+    def print_invoice(self):
         '''
         Generate invoice report and store it in invoice_report field.
         '''
-        if invoice.invoice_report_cache:
+        if self.invoice_report_cache:
             return
-        invoice_report = Pool().get('account.invoice', type='report')
-        invoice_report.execute([invoice.id], {})
+        InvoiceReport = Pool().get('account.invoice', type='report')
+        InvoiceReport.execute([self.id], {})
 
-    def _credit(self, invoice):
+    def _credit(self):
         '''
         Return values to credit invoice.
         '''
-        invoice_line_obj = Pool().get('account.invoice.line')
-        invoice_tax_obj = Pool().get('account.invoice.tax')
-
         res = {}
-        if invoice.type == 'out_invoice':
+        if self.type == 'out_invoice':
             res['type'] = 'out_credit_note'
-        elif invoice.type == 'in_invoice':
+        elif self.type == 'in_invoice':
             res['type'] = 'in_credit_note'
-        elif invoice.type == 'out_credit_note':
+        elif self.type == 'out_credit_note':
             res['type'] = 'out_invoice'
-        elif invoice.type == 'in_credit_note':
+        elif self.type == 'in_credit_note':
             res['type'] = 'in_invoice'
 
         for field in ('description', 'comment'):
-            res[field] = invoice[field]
+            res[field] = getattr(self, field)
 
-        res['reference'] = invoice.number or invoice.reference
+        res['reference'] = self.number or self.reference
 
         for field in ('company', 'party', 'invoice_address', 'currency',
                 'journal', 'account', 'payment_term'):
-            res[field] = invoice[field].id
+            res[field] = getattr(self, field).id
 
         res['lines'] = []
-        for line in invoice.lines:
-            value = invoice_line_obj._credit(line)
+        for line in self.lines:
+            value = line._credit()
             res['lines'].append(('create', value))
 
         res['taxes'] = []
-        for tax in invoice.taxes:
+        for tax in self.taxes:
             if not tax.manual:
                 continue
-            value = invoice_tax_obj._credit(tax)
+            value = tax._credit()
             res['taxes'].append(('create', value))
         return res
 
-    def credit(self, ids, refund=False):
+    @classmethod
+    def credit(cls, invoices, refund=False):
         '''
         Credit invoices and return ids of new invoices.
+        Return the list of new invoice
+        '''
+        MoveLine = Pool().get('account.move.line')
 
-        :param ids: a list of invoice id
-        :param refund: a boolean to specify the refund
-        :return: the list of new invoice id
-        '''
-        move_line_obj = Pool().get('account.move.line')
+        new_invoices = []
+        for invoice in invoices:
+            new_invoice = cls.create(invoice._credit())
+            new_invoices.append(new_invoice)
+            if refund:
+                cls.open([new_invoice])
+                if new_invoice.state == 'open':
+                    MoveLine.reconcile([l for l in invoice.lines_to_pay
+                            if not l.reconciliation] +
+                        [l for l in new_invoice.lines_to_pay
+                            if not l.reconciliation])
+        return new_invoices
 
-        new_ids = []
-        for invoice in self.browse(ids):
-            vals = self._credit(invoice)
-            new_id = self.create(vals)
-            new_ids.append(new_id)
-            if refund:
-                self.open([new_id])
-                new_invoice = self.browse(new_id)
-                if new_invoice.state == 'open':
-                    line_ids = [x.id for x in invoice.lines_to_pay
-                            if not x.reconciliation] + \
-                                    [x.id for x in new_invoice.lines_to_pay
-                                            if not x.reconciliation]
-                    move_line_obj.reconcile(line_ids)
-        return new_ids
-
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
+    def draft(cls, invoices):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('proforma')
-    def proforma(self, ids):
+    def proforma(cls, invoices):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('open')
-    def open(self, ids):
-        for invoice in self.browse(ids):
-            self.set_number(invoice)
-            self.create_move(invoice)
-            self.print_invoice(invoice)
+    def open(cls, invoices):
+        for invoice in invoices:
+            invoice.set_number()
+            invoice.create_move()
+            invoice.print_invoice()
 
+    @classmethod
     @ModelView.button_action('account_invoice.wizard_pay')
-    def pay(self, ids):
+    def pay(cls, invoices):
         pass
 
-    def process(self, ids):
+    @classmethod
+    def process(cls, invoices):
         paid = []
         open_ = []
-        for invoice in self.browse(ids):
+        for invoice in invoices:
             if invoice.state not in ('open', 'paid'):
                 continue
             if invoice.reconciled:
-                paid.append(invoice.id)
+                paid.append(invoice)
             else:
-                open_.append(invoice.id)
-        self.paid(paid)
-        self.open(open_)
+                open_.append(invoice)
+        cls.paid(paid)
+        cls.open(open_)
 
+    @classmethod
     @Workflow.transition('paid')
-    def paid(self, ids):
+    def paid(cls, invoices):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
+    def cancel(cls, invoices):
         pass
 
-Invoice()
-
 
 class InvoicePaymentLine(ModelSQL):
     'Invoice - Payment Line'
-    _name = 'account.invoice-account.move.line'
-    _description = __doc__
+    __name__ = 'account.invoice-account.move.line'
     invoice = fields.Many2One('account.invoice', 'Invoice', ondelete='CASCADE',
             select=True, required=True)
     line = fields.Many2One('account.move.line', 'Payment Line',
             ondelete='CASCADE', select=True, required=True)
 
-InvoicePaymentLine()
-
 
 class InvoiceLine(ModelSQL, ModelView):
     'Invoice Line'
-    _name = 'account.invoice.line'
+    __name__ = 'account.invoice.line'
     _rec_name = 'description'
-    _description = __doc__
-
     invoice = fields.Many2One('account.invoice', 'Invoice', ondelete='CASCADE',
         select=True, states={
             'required': (~Eval('invoice_type') & Eval('party')
@@ -1356,14 +1257,14 @@
             },
         depends=['invoice'])
     party_lang = fields.Function(fields.Char('Party Language',
-        on_change_with=['party']), 'get_party_language')
+        on_change_with=['party']), 'on_change_with_party_lang')
     currency = fields.Many2One('currency.currency', 'Currency',
         states={
             'required': ~Eval('invoice'),
             },
         depends=['invoice'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['currency']), 'get_currency_digits')
+        on_change_with=['currency']), 'on_change_with_currency_digits')
     company = fields.Many2One('company.company', 'Company',
         states={
             'required': ~Eval('invoice'),
@@ -1406,7 +1307,7 @@
             ],
         depends=['product', 'type', 'product_uom_category'])
     unit_digits = fields.Function(fields.Integer('Unit Digits',
-        on_change_with=['unit']), 'get_unit_digits')
+        on_change_with=['unit']), 'on_change_with_unit_digits')
     product = fields.Many2One('product.product', 'Product',
         states={
             'invisible': Eval('type') != 'line',
@@ -1419,7 +1320,7 @@
     product_uom_category = fields.Function(
         fields.Many2One('product.uom.category', 'Product Uom Category',
             on_change_with=['product']),
-        'get_product_uom_category')
+        'on_change_with_product_uom_category')
     account = fields.Many2One('account.account', 'Account',
         domain=[
             ('company', '=', Eval('_parent_invoice', {}).get('company',
@@ -1462,9 +1363,10 @@
     invoice_taxes = fields.Function(fields.One2Many('account.invoice.tax',
         None, 'Invoice Taxes'), 'get_invoice_taxes')
 
-    def __init__(self):
-        super(InvoiceLine, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(InvoiceLine, cls).__setup__()
+        cls._sql_constraints += [
             ('type_account',
                 'CHECK((type = \'line\' AND account IS NOT NULL) ' \
                         'OR (type != \'line\'))',
@@ -1473,13 +1375,13 @@
                 'CHECK((type != \'line\' AND invoice IS NOT NULL) ' \
                         'OR (type = \'line\'))',
                 'Line without "line" type must have an invoice!'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_account', 'account_different_company'),
             ('check_account2', 'same_account_on_invoice'),
-        ]
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._error_messages.update({
+            ]
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._error_messages.update({
             'modify': 'You can not modify line from an invoice ' \
                     'that is opened, paid!',
             'create': 'You can not add a line to an invoice ' \
@@ -1490,10 +1392,11 @@
                     'as on the invoice!',
             })
 
-    def init(self, module_name):
-        super(InvoiceLine, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(InvoiceLine, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 invoice is no more required
         table.not_null_action('invoice', action='remove')
